var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__markAsModule(exports);
__export(exports, {
  Stale: () => Stale,
  computedAsync: () => computedAsync,
  makeReactive: () => makeReactive
});
var import_quarx = __toModule(require("quarx"));
var import_conclure = __toModule(require("conclure"));
const reactiveFlows = new WeakMap();
function makeReactive(it, options = {}) {
  const { name = "makeReactive" } = options;
  if (reactiveFlows.has(it)) {
    return reactiveFlows.get(it);
  }
  const atom = (0, import_quarx.createAtom)(() => {
    const originalNext = it.next;
    const steps = [];
    it.next = (value) => {
      let result, error;
      let step = steps.length;
      const dispose = (0, import_quarx.autorun)(() => {
        if (step !== steps.length)
          return atom.reportChanged();
        try {
          result = originalNext.call(it, value);
          if ((0, import_conclure.isIterator)(result.value)) {
            makeReactive(result.value).reportObserved();
          }
        } catch (e) {
          error = e;
        }
      });
      steps.push(dispose);
      if (error)
        throw error;
      return result;
    };
    return () => {
      it.next = originalNext;
      for (let dispose of steps)
        dispose();
    };
  }, { name });
  reactiveFlows.set(it, atom);
  return atom;
}
class Stale extends Error {
}
;
function computedAsync(evaluate, options = {}) {
  const {
    name = "computedAsync",
    equals = (a, b) => a === b
  } = options;
  let result, error, cancel;
  function start() {
    const stop = (0, import_quarx.autorun)(computation);
    return () => {
      if (cancel)
        cancel();
      cancel = void 0;
      stop();
    };
  }
  const atom = (0, import_quarx.createAtom)(start, { name });
  function set(e, r) {
    error = e;
    if (!error) {
      if (equals(result, r))
        return;
      result = r;
    }
    atom.reportChanged();
  }
  function computation() {
    try {
      if (cancel)
        cancel();
      const value = evaluate();
      if ((0, import_conclure.isIterator)(value)) {
        makeReactive(value).reportObserved();
      }
      cancel = (0, import_conclure.conclude)(value, set);
      if ((0, import_conclure.isFlow)(value) && (0, import_conclure.inProgress)(value)) {
        set(new Stale(name));
      }
    } catch (err) {
      set(err);
    }
  }
  return {
    get: () => {
      if (!atom.reportObserved()) {
        computation();
      }
      ;
      if (error)
        throw error;
      return result;
    }
  };
}
